
#include "emusic.h"

int LoadCacheItem(struct playlist_item *song)
{
   char *filename;
   FILE *file;
   char buffer[FILEPATH_LEN_MAX];
   char *temp;
   int linenum = 0;

   EDBUG(7, "LoadCacheItem");
   filename = Emalloc(strlen(HomeDir) + strlen(song->path) + 20);
   strcpy(filename, HomeDir);
   strcat(filename, "/.emusic/.cache/");
   strcat(filename, song->path);
   if (!exists(filename)) {
      Efree(filename);
      EDBUG_RETURN(FALSE);
   }
   if (!(file = fopen(filename, "r"))) {
      Efree(filename);
      EDBUG_RETURN(FALSE);
   }
   Efree(filename);
   while (fgets(buffer, FILEPATH_LEN_MAX, file)) {
      if (buffer) {
         temp = strrchr(buffer, '\n');
         if (temp)
            *temp = '\0';
         switch (linenum) {
         case 0:
            if (strcmp(buffer, "0.8.2")) {
               fclose(file);
               EDBUG_RETURN(FALSE);
            }
            break;
         case 1:
            if (song->name)
               Efree(song->name);
            song->name = duplicate(buffer);
            break;
         case 2:
            if (song->title)
               Efree(song->title);
            song->title = duplicate(buffer);
            break;
         case 3:
            if (song->artist)
               Efree(song->artist);
            song->artist = duplicate(buffer);
            break;
         case 4:
            if (song->album)
               Efree(song->album);
            song->album = duplicate(buffer);
            break;
         case 5:
            if (song->year)
               Efree(song->year);
            song->year = duplicate(buffer);
            break;
         case 6:
            if (song->comment)
               Efree(song->comment);
            song->comment = duplicate(buffer);
            break;
         case 7:
            song->length = atoi(buffer);
            break;
         case 8:
            song->player = ReturnPlayerPlugin(buffer);
            break;
         case 9:
            song->stream_type = atoi(buffer);
            break;
         default:
            fclose(file);
            EDBUG_RETURN(FALSE);
            break;
         }
      }
      linenum++;
   }
   fclose(file);
   if (!song->title)
      song->title = duplicate(song->name);
   EDBUG_RETURN(TRUE);
}

void SaveItemCache(struct playlist_item *song)
{
   char *filename;
   FILE *file;
   int dummy;
   char temp[FILEPATH_LEN_MAX];

   EDBUG(7, "SaveItemCache");
   if (song->stream_type != TYPE_FILE)
      EDBUG_RETURN_;
   filename = Emalloc(strlen(HomeDir) + strlen(song->path) + 20);
   strcpy(filename, HomeDir);
   strcat(filename, "/.emusic/.cache/");
   strcat(filename, song->path);
   if (!exists(filename))
      mkdirs(filename);
   if (!(file = fopen(filename, "w"))) {
      Efree(filename);
      EDBUG_RETURN_;
   }
   Efree(filename);
   if (!sscanf(song->name, "(%d) - %[^\n]", &dummy, temp))
      strcpy(temp, song->name);
   fprintf(file, "0.8.2\n");
   fprintf(file, "%s\n", temp);
   if (song->title)
      fprintf(file, "%s\n", song->title);
   else
      fprintf(file, "\n");
   if (song->artist)
      fprintf(file, "%s\n", song->artist);
   else
      fprintf(file, "\n");
   if (song->album)
      fprintf(file, "%s\n", song->album);
   else
      fprintf(file, "\n");
   if (song->year)
      fprintf(file, "%s\n", song->year);
   else
      fprintf(file, "\n");
   if (song->comment)
      fprintf(file, "%s\n", song->comment);
   else
      fprintf(file, "\n");
   fprintf(file, "%d\n", song->length);
   fprintf(file, "%s\n", song->player->id);
   fprintf(file, "%d\n", song->stream_type);
   fclose(file);
   EDBUG_RETURN_;
}
