
#include "convert.h"
#include "../emusic.h"

char *tempskindir;
char *winamp_default_path;

void Convert_main(char *tempskindirlala)
{
   char *orig, *temp, *s;

   EDBUG(5, "Convery_main");
   tempskindir = duplicate(tempskindirlala);
   orig = Emalloc(strlen(origskin) + 256);
   s = FindFile("main.bmp", origskin);
   sprintf(orig, "%s", s);
   Efree(s);
   if (strcmp(orig, "(null)")) {
      ImlibImage *main_im, *ppm_im;

      ProcessImage("titlebar.bmp", "titlebar.ppm", 27, 0, 275, 14);
      temp = Emalloc(strlen(tempskindir) + 20);
      sprintf(temp, "%s/titlebar.ppm", tempskindir);
      ppm_im = LoadImlibImage(temp);
      rm(temp);
      ProcessImage("main.bmp", "main.ppm", 0, 0, 275, 116);
      sprintf(temp, "%s/main.ppm", tempskindir);
      main_im = LoadImlibImage(temp);
      memcpy(main_im->rgb_data, ppm_im->rgb_data, 11550);
      Imlib_changed_image(imlib, main_im);
      Imlib_save_image_to_ppm(imlib, main_im, temp);
      Imlib_kill_image(imlib, main_im);
      Imlib_kill_image(imlib, ppm_im);
   }
   else {
      temp = Emalloc(strlen(tempskindir) + 20);
      sprintf(orig, "%s/%s", winamp_default_path, "main.ppm");
      sprintf(temp, "%s/%s", tempskindir, "main.ppm");
      cp(orig, temp);
   }
   Efree(orig);
   Efree(temp);
   EDBUG_RETURN_;
}

int CheckForWinampSkinAt(char *path)
{
   char *s = NULL;

   EDBUG(4, "CheckForWinampSkinAt");
   s = FindFile("main.bmp", path);
   if (s) {
      Efree(s);
      EDBUG_RETURN(TRUE);
   }
   s = FindFile("cbuttons.bmp", path);
   if (s) {
      Efree(s);
      EDBUG_RETURN(TRUE);
   }
   s = FindFile("monoster.bmp", path);
   if (s) {
      Efree(s);
      EDBUG_RETURN(TRUE);
   }
   s = FindFile("numbers.bmp", path);
   if (s) {
      Efree(s);
      EDBUG_RETURN(TRUE);
   }
   s = FindFile("playpaus.bmp", path);
   if (s) {
      Efree(s);
      EDBUG_RETURN(TRUE);
   }
   s = FindFile("posbar.bmp", path);
   if (s) {
      Efree(s);
      EDBUG_RETURN(TRUE);
   }
   s = FindFile("shufrep.bmp", path);
   if (s) {
      Efree(s);
      EDBUG_RETURN(TRUE);
   }
   s = FindFile("text.bmp", path);
   if (s) {
      Efree(s);
      EDBUG_RETURN(TRUE);
   }
   s = FindFile("titlebar.bmp", path);
   if (s) {
      Efree(s);
      EDBUG_RETURN(TRUE);
   }
   s = FindFile("volume.bmp", path);
   if (s) {
      Efree(s);
      EDBUG_RETURN(TRUE);
   }
   EDBUG_RETURN(FALSE);
}

static void CopyMissing(char *to, char *filename)
{
   char sys[FILEPATH_LEN_MAX];

   
   EDBUG(4, "CopyMissing");
   sprintf(sys, "%s/%s", to, filename);
   if (!exists(sys)) {
      char *found = FindFile(filename, origskin);
 
      if (found)
         sprintf(sys, "cp -ra \"%s/%s\" %s/", origskin, found, to);
      else
         sprintf(sys, "cp -ra %s/%s %s/", winamp_default_path, filename, to);
      system(sys);
      if (found)
         Efree(found);
   }
}

void ConvertWinamp(char *ts)
{
   char sys[FILEPATH_LEN_MAX];

   EDBUG(4, "ConvertWinamp");
   sprintf(sys, "%s/nums_ex.bmp", ts);
   if (exists(sys)) {
      char temp[FILEPATH_LEN_MAX];

      sprintf(temp, "%s/numbers.bmp", ts);
      rename(sys, temp);
   }
   sprintf(sys, "%s/volbar.bmp", ts);
   if (exists(sys)) {
      char temp[FILEPATH_LEN_MAX];

      sprintf(temp, "%s/volume.bmp", ts);
      rename(sys, temp);
   }
   ConvertSetPath(ts);
   Convert_main(ts);
   CopyMissing(ts, "MAIN.theme");
   CopyMissing(ts, "a*");
   CopyMissing(ts, "cl*");
   CopyMissing(ts, "d*");
   CopyMissing(ts, "l*");
   CopyMissing(ts, "main.ppm");
   CopyMissing(ts, "na*");
   CopyMissing(ts, "playl*");
   CopyMissing(ts, "sa*");
   CopyMissing(ts, "sl*");
   CopyMissing(ts, "sm*");
   CopyMissing(ts, "u*");
   CopyMissing(ts, "cbuttons.bmp");
   CopyMissing(ts, "monoster.bmp");
   CopyMissing(ts, "numbers.bmp");
   CopyMissing(ts, "playpaus.bmp");
   CopyMissing(ts, "posbar.bmp");
   CopyMissing(ts, "shufrep.bmp");
   CopyMissing(ts, "text.bmp");
   CopyMissing(ts, "titlebar.bmp");
   CopyMissing(ts, "volume.bmp");
   ConvertFreePath();
   EDBUG_RETURN_;
}
