#include <gtk/gtk.h>
#include <gdk/gdkprivate.h>
#include "widget.h"

int FileBoxVisible = FALSE;
FileBox FileWinNoPointer;
FileBox *FileWin = &FileWinNoPointer;

extern int FileBoxDraw;
extern char *splitdir(char *dir);

void recursive_button(GtkWidget * button, GtkFileSelection * file)
{
   FileWin->recurse = GTK_TOGGLE_BUTTON(button)->active;
}

void file_ok_sel(GtkWidget * w, GtkFileSelection * file)
{
   /* Code for handing multiple selections gleaned from the gimp */
   char *raw_path = NULL;
   GList *row = GTK_CLIST(file->file_list)->row_list;
   gint rownum = 0;
   char *temp, *path_temp;

   FileWin->okdone = TRUE;
   FileWin->gtk_return_path =
      duplicate(gtk_file_selection_get_filename(GTK_FILE_SELECTION(file)));
   path_temp = duplicate(FileWin->gtk_return_path);
   splitdir(path_temp);
   
   raw_path = gtk_entry_get_text(GTK_ENTRY(file->selection_entry));
   while (row) {
      if (GTK_CLIST_ROW(row)->state == GTK_STATE_SELECTED) {
         if (gtk_clist_get_cell_type(GTK_CLIST(file->file_list), rownum, 0)
             == GTK_CELL_TEXT) {
            gtk_clist_get_text(GTK_CLIST(file->file_list), rownum, 0, &temp);
            if (!strcmp(temp, raw_path))
               goto next_iter;
            FileWin->gtk_return_path = Erealloc(FileWin->gtk_return_path,
                                                strlen(FileWin->gtk_return_path)
                                                + strlen(path_temp) + 
                                                strlen(temp) + 4);
            strcat(FileWin->gtk_return_path, "\n");
            strcat(FileWin->gtk_return_path, path_temp);
            strcat(FileWin->gtk_return_path, "/");
            strcat(FileWin->gtk_return_path, temp);
         }
      }
    next_iter:
      rownum++;
      row = g_list_next(row);
   }
   gtk_widget_destroy(GTK_WIDGET(file));
   Efree(path_temp);
}

void destroy(GtkWidget * w, gpointer data)
{
   FileBoxVisible = FALSE;
}

void DrawFileBox(void)
{
   GtkWidget *filed;
   GtkWidget *button;

   EDBUG(5, "PopUpFileBox");
   if (!FileWin->title)
      FileWin->title = duplicate("eMusic File Selector");
   filed = gtk_file_selection_new((const gchar *) FileWin->title);
   Efree(FileWin->title);
   FileWin->title = NULL;
   gtk_signal_connect(GTK_OBJECT(filed), "destroy", GTK_SIGNAL_FUNC(destroy), NULL);
   gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(filed)->ok_button),
                      "clicked", GTK_SIGNAL_FUNC(file_ok_sel), GTK_OBJECT(filed));
   gtk_signal_connect_object(GTK_OBJECT(GTK_FILE_SELECTION(filed)->cancel_button),
                             "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy),
                             GTK_OBJECT(filed));
   button = gtk_check_button_new_with_label("Recursive");
   gtk_signal_connect(GTK_OBJECT(button), "clicked",
                      GTK_SIGNAL_FUNC(recursive_button), (gpointer) filed);
   gtk_box_pack_start(GTK_BOX(GTK_FILE_SELECTION(filed)->action_area), button,
                      FALSE, FALSE, 0);
   gtk_widget_show(button);
   if (FileWin->gtk_return_path)
      gtk_file_selection_set_filename(GTK_FILE_SELECTION(filed), (gchar *) FileWin->gtk_return_path);
   FileBoxVisible = TRUE;
   gtk_clist_set_selection_mode(GTK_CLIST(GTK_FILE_SELECTION(filed)->file_list), GTK_SELECTION_EXTENDED);
   gtk_widget_show(filed);
   FileWin->okdone = FALSE;
   FileWin->recurse = FALSE;
}


void PopUpFileBox(void)
{
   EDBUG(2, "PopUpFileBox");
   FileWin->okdone = FALSE;
   FileBoxDraw = TRUE;
   while (FileBoxDraw)
      usleep(50);
   while (FileBoxVisible)
      usleep(50);
   if (FileWin->callback) {
      char *temp;
      
      temp = strtok(FileWin->gtk_return_path, "\n");
      FileWin->callback(temp);
      while ((temp = strtok(NULL, "\n"))) 
         FileWin->callback(temp);
   }
   EDBUG_RETURN_;
}

void SetFileBoxCallback(void (*call) (char *))
{
   FileWin->callback = call;
}
