
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>
#include <pthread.h>
#include "../common.h"

#include "gen.h"

extern int end_song;
extern int stop_song;
extern pthread_t player_thread;
extern pthread_mutex_t player_lock;

struct player_plugin *gen_plug;
WrapperList *list;
char *filename;

void gen_seek_to_frame(int second)
{
}

void *gen_thread(void *foo)
{
   char *command;
   struct wrapper_item *cur;

   pthread_setcancelstate(PTHREAD_CANCEL_ENABLE, NULL);
   if (!list || !list->first)
      goto gendone;
   cur = list->first;
   while (cur) {
      char *temp = strrchr(filename, '.');

      if (!(temp + 1))
         goto gendone;
      if (!strcasecmp((temp + 1), cur->extension))
         break;
      cur = cur->next;
   }
   command = Emalloc(strlen(cur->player) + strlen(filename) + 2);
   sprintf(command, "%s %s", cur->player, filename);
   system(command);
   Efree(command);
 gendone:
   end_song = 1;
   return NULL;
}

int gen_play(char *path)
{
   filename = duplicate(path);
   pthread_create(&player_thread, NULL, gen_thread, NULL);
   return 1;
}

void gen_pause_it(void)
{
}

void gen_stop(int playing)
{
   pthread_cancel(player_thread);
   pthread_join(player_thread, NULL);
   Efree(filename);
}

void gen_init(struct player_plugin *plug)
{
   gen_plug = plug;
}

void gen_get_info(struct playlist_item *song)
{
   song->length = 0;
}

void gen_config(char *left, char *right)
{
   struct wrapper_item *cur;

   if (!strncmp("BEGIN", left, 5) || !strncmp("END", left, 3))
      return;
   if (!list) {
      list = Emalloc(sizeof(WrapperList));
      list->first = NULL;
      list->last = NULL;
   }
   cur = list->first;
   if (cur) {
      while (cur->next)
         cur = cur->next;
      cur->next = Emalloc(sizeof(struct wrapper_item));

      list->last = cur->next;
      cur = cur->next;
   }
   else {
      cur = Emalloc(sizeof(struct wrapper_item));

      list->last = list->first = cur;
   }
   cur->next = NULL;
   cur->extension = duplicate(left);
   cur->player = duplicate(right);
   emusic_register_ext(cur->extension, gen_plug);
}

struct player_plugin *setup_plugin(void)
{
   struct player_plugin *temp = Emalloc(sizeof(struct player_plugin));

   temp->init = gen_init;
   temp->config = gen_config;
   temp->seek_to_frame = gen_seek_to_frame;
   temp->play = gen_play;
   temp->stop = gen_stop;
   temp->pause_it = gen_pause_it;
   temp->get_info = gen_get_info;
   temp->streamable = FALSE;
   temp->id = duplicate("genwrap");
   temp->version = duplicate("0.1");
   temp->copyright = duplicate("1998 Isaac Richards");
   return temp;
}
