/* Extended Module Player
 * Copyright (C) 1997 - 1998 Claudio Matsuoka and Hipolito Carraro Jr
 * $Id$
 *
 * This file is part of the Extended Module Player and is distributed
 * under the terms of the GNU General Public License. See doc/COPYING
 * for more information.
 */

/* Mixers
 *
 * To increase performance eight mixers are defined, one for each
 * combination of the following parameters: interpolation, resolution
 * and number of channels.
 */

#define INTERPOLATE()

#define DONT_INTERPOLATE()


/* Handler for 8 bit samples, interpolated stereo output */

.text
.globl mix_st8itpt
	.type	 mix_st8itpt,@function

mix_st8itpt:
	pushl %ebp
	movl %esp,%ebp
	subl $24,%esp
	pushl %edi
	pushl %esi
	pushl %ebx
	movl $0,-16(%ebp)
	movl $0,-24(%ebp)
	movl 16(%ebp),%edi
	movl 20(%ebp),%ebx
	movl Itpt_inc,%esi
	movl tbuffer,%ecx
	movl %esi,-20(%ebp)
	movl vol_left,%esi
	sall $8,%esi
	movl %esi,-8(%ebp)
	movl vol_right,%esi
	sall $8,%esi
	movl %esi,-12(%ebp)
	movl 8(%ebp),%esi
	decl %esi
	movl %esi,-4(%ebp)
	cmpl $-1,%esi
	je .L6
.L7:
	movl %ebx,%eax
	sarl $16,%eax
	je .L8
	addl %eax,%edi
	movl 12(%ebp),%esi
	andl $65535,%ebx
	movsbl (%edi,%esi),%esi
	movl %esi,-16(%ebp)
	movl 12(%ebp),%esi
	movsbl 1(%esi,%edi),%esi
	movl %esi,-24(%ebp)
	movl -16(%ebp),%esi
	subl %esi,-24(%ebp)
.L8:
	movl %ebx,%edx
	imull -24(%ebp),%edx
	sarl $16,%edx
	addl -16(%ebp),%edx
	movl %edx,%eax
	imull -12(%ebp),%eax
	addl %eax,(%ecx)
	addl $4,%ecx
	imull -8(%ebp),%edx
	addl %edx,(%ecx)
	addl $4,%ecx
	addl -20(%ebp),%ebx
	subl $1,-4(%ebp)
	jnc .L7
.L6:
	leal -36(%ebp),%esp
	popl %ebx
	popl %esi
	popl %edi
	movl %ebp,%esp
	popl %ebp
	ret
.Lfe1:
	.size	 mix_st8itpt,.Lfe1-mix_st8itpt


/* Handler for 16 bit samples, interpolated stereo output */

.globl mix_st16itpt
	.type	 mix_st16itpt,@function

mix_st16itpt:
	pushl %ebp
	movl %esp,%ebp
	subl $24,%esp
	pushl %edi
	pushl %esi
	pushl %ebx
	movl $0,-16(%ebp)
	movl $0,-24(%ebp)
	movl 16(%ebp),%edi
	movl 20(%ebp),%ebx
	movl Itpt_inc,%esi
	movl tbuffer,%ecx
	movl %esi,-20(%ebp)
	movl vol_left,%esi
	movl %esi,-8(%ebp)
	movl vol_right,%esi
	movl %esi,-12(%ebp)
	movl 8(%ebp),%esi
	decl %esi
	movl %esi,-4(%ebp)
	cmpl $-1,%esi
	je .L12
.L13:
	movl %ebx,%eax
	sarl $16,%eax
	je .L14
	addl %eax,%edi
	movl 12(%ebp),%esi
	andl $65535,%ebx
	movswl (%esi,%edi,2),%esi
	movl %esi,-16(%ebp)
	movl 12(%ebp),%esi
	movswl 2(%esi,%edi,2),%esi
	movl %esi,-24(%ebp)
	movl -16(%ebp),%esi
	subl %esi,-24(%ebp)
.L14:
	movl %ebx,%edx
	imull -24(%ebp),%edx
	sarl $16,%edx
	addl -16(%ebp),%edx
	movl %edx,%eax
	imull -12(%ebp),%eax
	addl %eax,(%ecx)
	addl $4,%ecx
	imull -8(%ebp),%edx
	addl %edx,(%ecx)
	addl $4,%ecx
	addl -20(%ebp),%ebx
	subl $1,-4(%ebp)
	jnc .L13
.L12:
	leal -36(%ebp),%esp
	popl %ebx
	popl %esi
	popl %edi
	movl %ebp,%esp
	popl %ebp
	ret
.Lfe2:
	.size	 mix_st16itpt,.Lfe2-mix_st16itpt


/* Handler for 8 bit samples, non-interpolated stereo output */

.globl mix_st8norm
	.type	 mix_st8norm,@function

mix_st8norm:
	pushl %ebp
	movl %esp,%ebp
	subl $12,%esp
	pushl %edi
	pushl %esi
	pushl %ebx
	movl Itpt_inc,%edi
	movl tbuffer,%ecx
	movl 8(%ebp),%ebx
	movl 20(%ebp),%esi
	movl %edi,-12(%ebp)
	decl %ebx
	movl 12(%ebp),%edi
	addl %edi,16(%ebp)
	movl vol_left,%edi
	sall $8,%edi
	movl %edi,-4(%ebp)
	movl vol_right,%edi
	sall $8,%edi
	movl %edi,-8(%ebp)
	cmpl $-1,%ebx
	je .L18
.L19:
	movl %esi,%eax
	movl 16(%ebp),%edi
	sarl $16,%eax
	movsbl (%eax,%edi),%edx
	movl %edx,%eax
	imull -8(%ebp),%eax
	addl %eax,(%ecx)
	addl $4,%ecx
	imull -4(%ebp),%edx
	addl %edx,(%ecx)
	addl $4,%ecx
	addl -12(%ebp),%esi
	subl $1,%ebx
	jnc .L19
.L18:
	leal -24(%ebp),%esp
	popl %ebx
	popl %esi
	popl %edi
	movl %ebp,%esp
	popl %ebp
	ret
.Lfe3:
	.size	 mix_st8norm,.Lfe3-mix_st8norm


/* Handler for 16 bit samples, non-interpolated stereo output */

.globl mix_st16norm
	.type	 mix_st16norm,@function

mix_st16norm:
	pushl %ebp
	movl %esp,%ebp
	subl $16,%esp
	pushl %edi
	pushl %esi
	pushl %ebx
	movl Itpt_inc,%edi
	movl tbuffer,%ecx
	movl 8(%ebp),%ebx
	movl 20(%ebp),%esi
	movl %edi,-12(%ebp)
	decl %ebx
	movl 16(%ebp),%edi
	addl %edi,%edi
	movl %edi,-16(%ebp)
	movl 12(%ebp),%edi
	addl %edi,-16(%ebp)
	movl vol_left,%edi
	movl %edi,-4(%ebp)
	movl vol_right,%edi
	movl %edi,-8(%ebp)
	cmpl $-1,%ebx
	je .L23
.L24:
	movl %esi,%eax
	movl -16(%ebp),%edi
	sarl $16,%eax
	movswl (%edi,%eax,2),%edx
	movl %edx,%eax
	imull -8(%ebp),%eax
	addl %eax,(%ecx)
	addl $4,%ecx
	imull -4(%ebp),%edx
	addl %edx,(%ecx)
	addl $4,%ecx
	addl -12(%ebp),%esi
	subl $1,%ebx
	jnc .L24
.L23:
	leal -28(%ebp),%esp
	popl %ebx
	popl %esi
	popl %edi
	movl %ebp,%esp
	popl %ebp
	ret
.Lfe4:
	.size	 mix_st16norm,.Lfe4-mix_st16norm


/* Handler for 8 bit samples, interpolated mono output */

.globl mix_mn8itpt
	.type	 mix_mn8itpt,@function

mix_mn8itpt:
	pushl %ebp
	xorl %ecx,%ecx
	movl %esp,%ebp
	subl $16,%esp
	pushl %edi
	pushl %esi
	pushl %ebx
	movl $0,-4(%ebp)
	movl 16(%ebp),%esi
	movl 20(%ebp),%edx
	movl Itpt_inc,%edi
	movl tbuffer,%ebx
	movl %edi,-12(%ebp)
	movl vol_left,%edi
	sall $9,%edi
	movl %edi,-8(%ebp)
	movl 8(%ebp),%edi
	decl %edi
	movl %edi,-16(%ebp)
	cmpl $-1,%edi
	je .L28
.L29:
	movl %edx,%eax
	sarl $16,%eax
	je .L30
	addl %eax,%esi
	movl 12(%ebp),%edi
	andl $65535,%edx
	movsbl (%esi,%edi),%edi
	movl %edi,-4(%ebp)
	movl 12(%ebp),%edi
	movsbl 1(%edi,%esi),%ecx
	subl -4(%ebp),%ecx
.L30:
	movl %edx,%eax
	imull %ecx,%eax
	sarl $16,%eax
	addl -4(%ebp),%eax
	imull -8(%ebp),%eax
	addl %eax,(%ebx)
	addl $4,%ebx
	addl -12(%ebp),%edx
	subl $1,-16(%ebp)
	jnc .L29
.L28:
	leal -28(%ebp),%esp
	popl %ebx
	popl %esi
	popl %edi
	movl %ebp,%esp
	popl %ebp
	ret
.Lfe5:
	.size	 mix_mn8itpt,.Lfe5-mix_mn8itpt


/* Handler for 16 bit samples, interpolated mono output */

.globl mix_mn16itpt
	.type	 mix_mn16itpt,@function

mix_mn16itpt:
	pushl %ebp
	xorl %ecx,%ecx
	movl %esp,%ebp
	subl $16,%esp
	pushl %edi
	pushl %esi
	pushl %ebx
	movl $0,-4(%ebp)
	movl 16(%ebp),%esi
	movl 20(%ebp),%edx
	movl Itpt_inc,%edi
	movl tbuffer,%ebx
	movl %edi,-12(%ebp)
	movl vol_left,%edi
	addl %edi,%edi
	movl %edi,-8(%ebp)
	movl 8(%ebp),%edi
	decl %edi
	movl %edi,-16(%ebp)
	cmpl $-1,%edi
	je .L34
.L35:
	movl %edx,%eax
	sarl $16,%eax
	je .L36
	addl %eax,%esi
	movl 12(%ebp),%edi
	andl $65535,%edx
	movswl (%edi,%esi,2),%edi
	movl %edi,-4(%ebp)
	movl 12(%ebp),%edi
	movswl 2(%edi,%esi,2),%ecx
	subl -4(%ebp),%ecx
.L36:
	movl %edx,%eax
	imull %ecx,%eax
	sarl $16,%eax
	addl -4(%ebp),%eax
	imull -8(%ebp),%eax
	addl %eax,(%ebx)
	addl $4,%ebx
	addl -12(%ebp),%edx
	subl $1,-16(%ebp)
	jnc .L35
.L34:
	leal -28(%ebp),%esp
	popl %ebx
	popl %esi
	popl %edi
	movl %ebp,%esp
	popl %ebp
	ret
.Lfe6:
	.size	 mix_mn16itpt,.Lfe6-mix_mn16itpt


/* Handler for 8 bit samples, non-interpolated mono output */

.globl mix_mn8norm
	.type	 mix_mn8norm,@function

mix_mn8norm:
	pushl %ebp
	movl %esp,%ebp
	subl $8,%esp
	pushl %edi
	pushl %esi
	pushl %ebx
	movl Itpt_inc,%edi
	movl tbuffer,%edx
	movl 16(%ebp),%esi
	movl 8(%ebp),%ecx
	movl 20(%ebp),%ebx
	movl %edi,-4(%ebp)
	addl 12(%ebp),%esi
	decl %ecx
	movl vol_left,%edi
	sall $9,%edi
	movl %edi,-8(%ebp)
	cmpl $-1,%ecx
	je .L40
.L41:
	movl %ebx,%eax
	sarl $16,%eax
	movsbl (%eax,%esi),%eax
	imull -8(%ebp),%eax
	addl %eax,(%edx)
	addl $4,%edx
	addl -4(%ebp),%ebx
	subl $1,%ecx
	jnc .L41
.L40:
	leal -20(%ebp),%esp
	popl %ebx
	popl %esi
	popl %edi
	movl %ebp,%esp
	popl %ebp
	ret
.Lfe7:
	.size	 mix_mn8norm,.Lfe7-mix_mn8norm


/* Handler for 16 bit samples, non-interpolated mono output */

.globl mix_mn16norm
	.type	 mix_mn16norm,@function

mix_mn16norm:
	pushl %ebp
	movl %esp,%ebp
	subl $8,%esp
	pushl %edi
	pushl %esi
	pushl %ebx
	movl Itpt_inc,%edi
	movl tbuffer,%edx
	movl 16(%ebp),%esi
	movl 8(%ebp),%ecx
	movl 20(%ebp),%ebx
	movl %edi,-4(%ebp)
	addl %esi,%esi
	decl %ecx
	movl vol_left,%edi
	addl 12(%ebp),%esi
	addl %edi,%edi
	movl %edi,-8(%ebp)
	cmpl $-1,%ecx
	je .L45
.L46:
	movl %ebx,%eax
	sarl $16,%eax
	movswl (%esi,%eax,2),%eax
	imull -8(%ebp),%eax
	addl %eax,(%edx)
	addl $4,%edx
	addl -4(%ebp),%ebx
	subl $1,%ecx
	jnc .L46
.L45:
	leal -20(%ebp),%esp
	popl %ebx
	popl %esi
	popl %edi
	movl %ebp,%esp
	popl %ebp
	ret
.Lfe8:
	.size	 mix_mn16norm,.Lfe8-mix_mn16norm
